VisualEditor: Strip whitespace from the start of paragraphs before sending to Parsoid
Closed, ResolvedPublic

bzimport set Reference to bz51462.
Ironholds created this task.Via LegacyJul 16 2013, 7:06 PM
ssastry added a comment.Via ConduitJul 16 2013, 8:18 PM

If VE can strip leading whitespace in paragraphs, that will eliminate these errors. Alternatively, Parsoid can do that normalization. Unclear where this should be done. Will discuss on IRC.

ssastry added a comment.Via ConduitJul 16 2013, 8:25 PM

Without whitespace stripping (either in VE or Parsoid) and no nowiki, that text will become <pre>-formatted.

Quickly discussed with Gabriel on IRC. It is probably better fixed in VE since Parsoid doesn't have contextual information about where the space is meaningful or not.

If leading whitespace at start of line is desired by the editor, then VE should convert them to &nbsp; or if nowikis are acceptable, the spaces can be left alone. In either case, this kind of edits should hopefully be rare.

ssastry added a comment.Via ConduitJul 18 2013, 5:30 PM
  • Bug 51509 has been marked as a duplicate of this bug. ***
Esanders added a comment.Via ConduitJul 30 2013, 4:25 PM

With bug 50841 we now convert

[space]Foo

to

<nowiki> </nowiki>Foo

(previously <nowiki> Foo</nowiki>)

This is the correct behaviour.

We should be careful going do the road of automatically correcting what we believe to be typos. Perhaps this, and other whitespace issues (e.g. double spaces), should be flagged up to the user (with a wiggle underline?)

ssastry added a comment.Via ConduitJul 30 2013, 5:02 PM
  • Bug 52252 has been marked as a duplicate of this bug. ***
Jdforrester-WMF added a comment.Via ConduitJul 30 2013, 6:14 PM

(In reply to comment #5)

With bug 50841 we now convert

[space]Foo

to

<nowiki> </nowiki>Foo

(previously <nowiki> Foo</nowiki>)

This is the correct behaviour.

Also, with gerrit 76223 VisualEditor users can now edit through <nowiki>s transparently.

Perhaps this, and other whitespace issues (e.g. double
spaces), should be flagged up to the user (with a wiggle underline?)

That would be one solution that is quite generalisable, but could be a great deal more work.

gerritbot added a comment.Via ConduitAug 2 2013, 11:38 AM

Change 77287 had a related patch set uploaded by Esanders:
[WIP] Remove inserted leading whitepsace

https://gerrit.wikimedia.org/r/77287

Esanders added a comment.Via ConduitAug 2 2013, 1:11 PM

So I just implemented a fix for this, but it broke a test that asserts that whitespace inside a pre is untouched. I'll put it a check for <pre> elements but we should be aware that this is broken, because any element can have white-space:pre attached to it, e.g.

<span style="white-space:pre"> Foo</span>

Will now normalise to

<span style="white-space:pre">Foo</span>

Long term we should look into just warning the user.

gerritbot added a comment.Via ConduitAug 2 2013, 7:03 PM

Change 77287 merged by jenkins-bot:
Remove inserted leading whitespace

https://gerrit.wikimedia.org/r/77287

Jdforrester-WMF added a comment.Via ConduitAug 2 2013, 8:27 PM

Now fixed in the code; next scheduled deployment is not until 15 August,
however. :-(

Elitre added a comment.Via ConduitAug 29 2013, 10:01 AM

Reopening as this is still happening:
first nowiki after line 133 in https://en.wikipedia.org/w/index.php?title=Pet&diff=570614739&oldid=570586939 .

Elitre added a comment.Via ConduitAug 29 2013, 10:41 AM

I am also filing a related common problem we meet at it.wp.
If this is not the right place, just tell me and I'll copy/paste my report elsewhere.

We had troubles with nowikis being thrown right after some templates when the user did not add an extra space there, but simply edited something in that page. See https://it.wikipedia.org/w/index.php?title=Wikipedia&diff=61171396&oldid=61171228 .

We actually found a workaround for this: https://it.wikipedia.org/w/index.php?title=Template:Quote&curid=224372&diff=61173726&oldid=60749506 but since this addition is apparently a nonsense, users demand that VE prevents that behaviour instead.

They also think this is related to templates featuring some kind of table.

I did some tests as well.
I was able to reproduce an unwanted situation where the first line and the table (which is actually a template) were mingled in a non-editable block https://it.wikipedia.org/w/index.php?title=Utente%3AElitre_%28WMF%29%2FSandbox_VE&diff=61181542&oldid=61181524 .

But I was also able to avoid nowikis, even if the extra span tags were not added to the template: as you can see here https://it.wikipedia.org/w/index.php?title=Utente:Elitre_(WMF)/Sandbox_VE&diff=prev&oldid=61181473, if the first letter of the line is actually closer to the template's final brace (with no space between), VEditing that page will result in the text getting automatically placed in a better position, and no nowikis in sight, even after multiple saves of the page.

Thanks.

Jdforrester-WMF added a comment.Via ConduitAug 29 2013, 6:15 PM

(In reply to comment #12)

Reopening as this is still happening:
first nowiki after line 133 in
https://en.wikipedia.org/w/index.
php?title=Pet&diff=570614739&oldid=570586939 .

That's almost certainly using a cached version of the code; I can't reproduce that on Chrome/Firefox/Safari/Opera on Mac or Linux.

(In reply to comment #13)

I am also filing a related common problem we meet at it.wp.
If this is not the right place, just tell me and I'll copy/paste my report
elsewhere.

Yeah, if you could file this as a new bug please - this is not related to removing whitespace from the start of paragraphs.

Mattflaschen removed a subscriber: Mattflaschen.Via WebDec 3 2014, 5:36 AM

Add Comment